<?
Function HM_WochenTempProfil_html($ID_tempProfile, $day_hl=99)
	{
	// Diese Funktion Wandelt ein mittels HMXML_getTempProfile ausgelesenes Temperatur Profil eines
	// HM Wandthermostaten Zwecks Anzeige in eine Web-Tabelle um

	//$ID_tempProfile=26666 ;
	//$ID_html=56170 ;

	$dayArray = array("MONDAY","TUESDAY","WEDNESDAY","THURSDAY","FRIDAY","SATURDAY","SUNDAY");
	$dayArray_germ = array("Mo","Di","Mi","Do","Fr","Sa","So");
	$tempProfile=unserialize(Getvalue($ID_tempProfile));

	$bgcolor[1]='#0101DF'; // #3399CC'; // kalt <= 15
	$bgcolor[2]='#01DF3A'; // #33CC66'; // Absenktemperatur grn <= 17
	$bgcolor[3]='#D7DF01'; // #FFCC66'; // Komforttemperatur <=23
	$bgcolor[4]='#DF0101'; // #FF3366'; // hei >23

	$bgcolor_hl[1]='#08088A'; // #339966'; // kalt <= 15
	$bgcolor_hl[2]='#088A29'; // #009966'; // Absenktemperatur grn <= 17
	$bgcolor_hl[3]='#868A08'; // #FF9966'; // Komforttemperatur <=23
	$bgcolor_hl[4]='#8A0808'; // #FF33FF'; // hei >23



	//*********************
	// tempProfile zerlegen
	//*********************

	Foreach ($dayArray as $daykey => $day)
		{
		$time1='00:00';
		Foreach ($tempProfile[$dayArray[$daykey]]['EndTimes'] as $time2)
			{
			$times[$day][]=(strtotime($time2)-strtotime($time1))/60; // Speicherslots des HM WT in min
			$time1=$time2;
			}
			Foreach ($tempProfile[$dayArray[$daykey]]['Values'] as $Value)
				{
				If ($Value<=15)  // kalt
					{
					$temp[$day][]=1;
					}
					elseif ($Value <=17)  // Absenktemperatur
						{
						$temp[$day][]=2;
						}
						elseif ($Value <=22)  // Komforttemperatur
							{
							$temp[$day][]=3;
							}
							else   // hei
								{
								$temp[$day][]=4;
								}
					}
		}

	//print_r ($times[0]);
	//print_r ($temp[0]);

	//************************
	// html Tabelle generieren
	//************************

	$str = "<table border=0 cellpadding=0 cellspacing=0 width=100% align='center'>
			 <tr height=35 align='right'> <td align='left' width=4%> </td>";

	for($i=1; $i <= 24; $i++)
		{
	   $str .="<td colspan=6 width=4% >$i</td>";
		}
	$str .=" </tr>";


	Foreach ($dayArray as $daykey => $day)
		{
		$str .="<tr height=25> <td>". $dayArray_germ[$daykey] ."</td>";
		Foreach ($times[$day] as $key => $time)
			{
			If ($day_hl<>$daykey) // wurde Wochentag mit bergeben (0=Mo, 1=Di ... 99=kein Wochentag vorgegeben)
			   {
			   $str .="<td colspan=". ($time/10) ." bgcolor=". $bgcolor[$temp[$day][$key]] ."> </td>";
				}
			  else
				{
				$str .="<td colspan=". ($time/10) ." bgcolor=". $bgcolor_hl[$temp[$day][$key]] ."> </td>";
				}
			}
		$str .="</tr>";
		}
   $str .="</table> <br>";
   
   $str .= "<table border=0 cellpadding=3 cellspacing=5 width=100% align='center'>";
	$str .= "<tr height=25 > ";
	$str .= "<td width=8% align='left'> Index: </td>";
	$str .= "<td width=23% bgcolor= $bgcolor[1] align='center'> <= 15C</td>";
   $str .= "<td width=23% bgcolor= $bgcolor[2] align='center'> 15.1C - 17C </td>";
   $str .= "<td width=23% bgcolor= $bgcolor[3] align='center'> 17.1C - 22C </td>";
   $str .= "<td width=23% bgcolor= $bgcolor[4] align='center'> > 22C </td>";

	$str .="</table>";
	return $str;
	}


Function HM_TagesTempProfil_html($Tages_Profil, $slot_hl=99)
	{
	$start="00:00";
	$str = "<table align='center' border=0 cellpadding=3 cellspacing=3 width=90%>
								<tr height=30 ><th> Slot </th><th> Start </th><th> Ende </th><th> SollWert</th></tr>";

	Foreach ($Tages_Profil['EndTimes'] as $key=> $EndTime)
			 {
			 $SollWert = number_format( $Tages_Profil['Values'][$key], 1,",",".");
			 If ($key<>$slot_hl-1)
				 {
				 $str .= "<tr  align='center' height=25> <td width=25%> Slot " .($key+1) ."</td><td width=25%> $start </td><td width=25%> $EndTime </td><td width=25%> $SollWert C</td></tr>";
				 }
				else
				 {
				 $str .= "<tr  bgcolor=#1A2B3C align='center' height=25> <td width=25%> Slot " .($key+1) ."</td><td width=25%> $start </td><td width=25%> $EndTime </td><td width=25%> $SollWert C</td></tr>";
				 }
			 $start=$EndTime;
			 }

	$str .= "</table>";

	// Auswahl-Zeit-Slot in Webfront Anzeige auf Anzahl der belegten Slots im HM WT beschrnken
	IPS_SetVariableProfileValues ("HM_Heizung_Slot", 1 , $key+1 , 1 );

	return $str;
	}

Function HM_WochenTempProfil_prfen($ID_tempProfile)
	{
	$Ergebnis="OK";
	$dayArray = array("MONDAY","TUESDAY","WEDNESDAY","THURSDAY","FRIDAY","SATURDAY","SUNDAY");
	$dayArray_germ = array("Mo","Di","Mi","Do","Fr","Sa","So");
	$tempProfile=unserialize(Getvalue($ID_tempProfile));

	Foreach ($dayArray as $daykey => $day)
		{
  		$time1='00:00';
		Foreach ($tempProfile[$dayArray[$daykey]]['EndTimes'] as $Slotkey => $time2)
			{
         If (strtotime($time2)<= strtotime($time1)) // Speicherslots des HM WT in min
				{
				$Slot=$Slotkey+1;
				$Ergebnis="Fehler im Tagesprofil $dayArray_germ[$daykey] (Slot: $Slot Start: $time1 - Ende: $time2 )";
				break;
				}
			$time1=$time2;
			}
		}
	 return $Ergebnis;
	}


?>